package cn.com.qmth.stmms.ms.collect.util;

import java.io.File;
import java.io.FileInputStream;
import java.io.FileNotFoundException;
import java.io.IOException;
import java.io.InputStream;
import java.util.HashSet;

import org.apache.commons.codec.digest.DigestUtils;

import cn.com.qmth.stmms.ms.commons.config.SystemConfig;
import cn.com.qmth.stmms.ms.commons.utils.image.ImageCompression;
import cn.com.qmth.stmms.ms.core.domain.Paper;
import cn.com.qmth.stmms.ms.core.repository.PaperRepo;

public class RotateTask  implements Runnable {
	
    private Paper paper;
    private int degree;
    private PaperRepo paperRepo;
    private SystemConfig systemConfig;
    private HashSet<String> papers;

    public RotateTask(Paper paper,int degree, PaperRepo paperRepo, SystemConfig systemConfig, HashSet<String> papers) {
    	this.paper = paper;
        this.degree = degree;
        this.paperRepo = paperRepo;
        this.systemConfig = systemConfig;
        this.papers = papers;
    }

	@Override
	public void run() {
		long start = System.currentTimeMillis();
		try {
			String thumbPath = systemConfig.getThumbDir() + File.separator + paper.getWorkId() + File.separator + paper.getSubject().toString()
					+ File.separator + paper.getAreaCode() + File.separator + paper.getExamNumber() + ".jpg";
			String thumbNew =  systemConfig.getThumbDir() + File.separator + paper.getWorkId() + File.separator + paper.getSubject().toString()
	    			+ File.separator + paper.getAreaCode() + File.separator + paper.getExamNumber() +"_" + start + ".jpg";
			File thumbFile = new File(thumbPath);
			if (thumbFile.exists()) {
				thumbFile.renameTo(new File(thumbNew));
				InputStream is = new FileInputStream(thumbNew);
				ImageCompression.rotate(new File(thumbNew), new File(thumbPath), degree);
				is.close();
			}
			
		    String imagePath = systemConfig.getImageDir() + File.separator + paper.getWorkId() + File.separator + paper.getSubject().toString()
		    			+ File.separator + paper.getAreaCode() + File.separator + paper.getExamNumber() + ".jpg";
		    String imageNew = systemConfig.getImageDir() + File.separator + paper.getWorkId() + File.separator + paper.getSubject().toString()
		    			+ File.separator + paper.getAreaCode() + File.separator + paper.getExamNumber() +"_" + start + ".jpg";
			File imageFile = new File(imagePath);
			if (imageFile.exists()) {
				imageFile.renameTo(new File(imageNew));
				InputStream is = new FileInputStream(imageNew);
				ImageCompression.rotate(new File(imageNew), new File(imagePath), degree);
				is.close();
			}
	        FileInputStream in = new FileInputStream(new File(imagePath));
	        String sliceMD5 = DigestUtils.md5Hex(in);
			paper.setSliceMD5(sliceMD5);
			paperRepo.save(paper);
			in.close();
		} catch (FileNotFoundException e) {
			e.printStackTrace();
		} catch (IOException ioe) {
			ioe.printStackTrace();
		} finally {
			papers.remove(paper.getExamNumber());
		}
	}
}
